

#include <stm32f10x.h>

#include "SPI.h"
#include "Utilitaires.h"
#include "MCP2515.h"


#define MCP2515_CHOIX_IDENTIFIANT 0x042


int main(void)
{
  	int IdentifiantReceptionCAN = 0x0000;
	int IdentifiantEmissionCAN = 0x0000;

	unsigned char LongueurReceptionCAN = 0;

	unsigned char TamponEmissionCAN[8] = {0x00};
	unsigned char TamponReceptionCAN[8] = {0x00};

	RCC->APB2ENR |= (1 << 2);	/* Activation de l'horloge du port A */
	
	InitSPI1();

	InitMCP2515();

	ChoisirIdentifiantTX0(MCP2515_CHOIX_IDENTIFIANT);

	while(1)
	{
		IdentifiantReceptionCAN = RecupererIdentifiantRX0();

		LongueurReceptionCAN = RecupererTrameMCP2515(TamponReceptionCAN);
		
		EnvoyerTrameMCP2515("COUCOU !\0");
	}

}



/*Fonction qui permet l'initialisation du microcontrleur STM32F100RB

Paramtre d'entre :

Aucun.

Valeur de retour :

Aucune.

*/
void SystemInit (void)
{
	RCC->CR |= 0x01;
	while((RCC->CR & ~(1 << 1)) == 0x00);
	RCC->CR |= (1 << 16);
	while((RCC->CR & ~(1 << 17)) == 0x00);
	
	RCC->CFGR |= (4 << 18);
	RCC->CFGR |= (1 << 16);
	
	RCC->CFGR |= 0x02;
	
	RCC->CR |= (1 << 24);
	while((RCC->CR & ~(1 << 24)) == 0x00);
	RCC->CFGR |= 0x02;
}


